//****************************************************************************//
// Manuel Martínez Liébana                                                    //
// TFC - Ingeniería Técnica Informática de Gestión                            //
// UOC - 2012                                                                 //
//****************************************************************************//

#include "curvaswindow.h"
#include "ui_curvaswindow.h"
#include <QKeyEvent>
#include <QMessageBox>

CurvasWindow::CurvasWindow(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::CurvasWindow)
{
    extern DBHandler *DB;
    ui->setupUi(this);
    DB->getDataFromTable(ui->tablaCurvas,"curvas");
    if (ui->tablaCurvas->rowCount())
    {
        ui->tablaCurvas->selectRow(0);
        DB->getDataFromCurve(ui->tablaDetalleCurva,ui->tablaCurvas->item(0,0)->text());
    }


}

CurvasWindow::~CurvasWindow()
{
    delete ui;
}

void CurvasWindow::on_insertarCurvaButton_clicked()
{
    extern DBHandler *DB;
    int iRet=-1;
    NuevaCurvaWindow *ventanaNuevaCurva = new NuevaCurvaWindow(this);
    iRet=ventanaNuevaCurva->exec();
    if( iRet == QDialog::Accepted )
    {
        DB->getDataFromTable(ui->tablaCurvas,"curvas");
        if (ui->tablaCurvas->rowCount())
        {
            ui->tablaCurvas->selectRow(0);
            DB->getDataFromCurve(ui->tablaDetalleCurva,ui->tablaCurvas->item(0,0)->text());
        }
    }
    delete ventanaNuevaCurva;
}

void CurvasWindow::keyPressEvent(QKeyEvent *e)
{
    if(e->key()!=Qt::Key_Return)
        QDialog::keyPressEvent(e);
}

void CurvasWindow::on_eliminarCurvaButton_clicked()
{
    extern DBHandler *DB;
    QString curvaID;
    int numCurvas=0;
    if (!ui->tablaCurvas->rowCount())
    {
        QMessageBox::warning(0,"Eliminar","La tabla esta vacia");
        return;
    }
    curvaID=ui->tablaCurvas->item(ui->tablaCurvas->currentRow(),0)->text();

    QString mensaje = "Se va a proceder a borrar la curva: ";
    mensaje.append(curvaID);
    QStringList *lista=NULL;

    switch( QMessageBox::warning( this, "Finanval",mensaje,"Si","No", 0, 0, 1 ))
    {
    case 0:
        lista=DB->getDealsContainingCurve(curvaID);

        numCurvas=lista->count();
        if (numCurvas)
        {
            mensaje="La curva esta incluida en los contratos: ";
            for (int i=0; i<numCurvas; i++)
            {
                if (i)
                    mensaje.append(", ");
                mensaje.append(lista->value(i));
            }
            mensaje.append("\nElimine o sustituya esta curva en los contratos correspondientes antes de proceder");
            QMessageBox::critical(0,"Error",mensaje);
            delete lista;
            return;
        }
        else
        {
            if (DB->deleteCurva(curvaID)) //Si todo fue bien repintamos la tabla
            {
                DB->getDataFromTable(ui->tablaCurvas,"curvas");
                if (ui->tablaCurvas->rowCount())
                {
                    ui->tablaCurvas->selectRow(0);
                    DB->getDataFromCurve(ui->tablaDetalleCurva,ui->tablaCurvas->item(0,0)->text());
                }
            }
            delete lista;
        }
        break;
    case 1:
        return;
        break;
    }
}

void CurvasWindow::on_tablaCurvas_cellClicked(int row, int column)
{
    extern DBHandler *DB;
    ui->tablaCurvas->selectRow(row);
    DB->getDataFromTable(ui->tablaCurvas,"curvas");
    DB->getDataFromCurve(ui->tablaDetalleCurva,ui->tablaCurvas->item(row,0)->text());
}

void CurvasWindow::on_tablaCurvas_cellEntered(int row, int column)
{
    extern DBHandler *DB;
    ui->tablaCurvas->selectRow(row);
    DB->getDataFromTable(ui->tablaCurvas,"curvas");
    DB->getDataFromCurve(ui->tablaDetalleCurva,ui->tablaCurvas->item(row,0)->text());
}

void CurvasWindow::on_pushButton_4_clicked()
{
    extern DBHandler *DB;
    int row=0;
    row=ui->tablaCurvas->currentRow();
    DB->getDataFromCurve(ui->tablaDetalleCurva,ui->tablaCurvas->item(row,0)->text());
}
