//****************************************************************************//
// Manuel Martínez Liébana                                                    //
// TFC - Ingeniería Técnica Informática de Gestión                            //
// UOC - 2012                                                                 //
//****************************************************************************//

#include "fijacioneswindow.h"
#include "ui_fijacioneswindow.h"
#include <QMessageBox>
#include <DBTools.h>

FijacionesWindow::FijacionesWindow(QString mIndice, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::FijacionesWindow)
{
    extern DBHandler *DB;
    indice=mIndice;
    ui->setupUi(this);
    DB->getFijacionesFromIndice(ui->tableWidgetFijaciones, indice);
}

FijacionesWindow::~FijacionesWindow()
{
    delete ui;
}

void FijacionesWindow::on_tableWidgetFijaciones_cellClicked(int row, int column)
{
    ui->tableWidgetFijaciones->selectRow(row);
}


void FijacionesWindow::on_pushButtonEliminar_clicked()
{
    extern DBHandler *DB;
    QString fechaFijacion;
    bool bret=false;
    if (!ui->tableWidgetFijaciones->rowCount())
    {
        QMessageBox::warning(0,"Eliminar","La tabla esta vacia");
        return;
    }
    fechaFijacion=ui->tableWidgetFijaciones->item(ui->tableWidgetFijaciones->currentRow(),0)->text();
    bret=DB->deleteFijacion(indice, fechaFijacion);
    if (bret)
    {
        QMessageBox::information(0,"Eliminar","Fijacion eliminada con exito");
        DB->getFijacionesFromIndice(ui->tableWidgetFijaciones, indice);
    }
}

void FijacionesWindow::on_pushButtonAnadir_clicked()
{
    extern DBHandler *DB;
    bool bret=false;

    bret=DB->insertIntoFijaciones(indice, ui->dateEdit->date(), ui->doubleSpinBox->value());
    if (bret)
    {
        QMessageBox::information(0,"Insercion en Base de Datos","Fijacion insertada con exito");
        DB->getFijacionesFromIndice(ui->tableWidgetFijaciones, indice);
    }
}

void FijacionesWindow::on_calendarWidget_clicked(const QDate &date)
{
    ui->dateEdit->setDate(date);
}
