//****************************************************************************//
// Manuel Martínez Liébana                                                    //
// TFC - Ingeniería Técnica Informática de Gestión                            //
// UOC - 2012                                                                 //
//****************************************************************************//

#include "utils.h"
#include <QDebug>
#include <QPainter>
#include <QPaintEvent>
#include <nightcharts.h>
#include <DBTools.h>
#include <QComboBox>
#include <vector>
#include <QRect>

using namespace std;

MyQFrame::MyQFrame(QWidget *parent):QFrame(parent)
{

}

void MyQFrame::paintEvent(QPaintEvent *e)
{

    extern DBHandler *DB;
    int color=7, num_productos=0;
    vector<Qt::GlobalColor> colores;
    colores.push_back(Qt::red);
    colores.push_back(Qt::green);
    colores.push_back(Qt::blue);
    colores.push_back(Qt::cyan);
    colores.push_back(Qt::magenta);
    colores.push_back(Qt::yellow);
    colores.push_back(Qt::darkRed);
    colores.push_back(Qt::darkGreen);
    colores.push_back(Qt::darkBlue);
    colores.push_back(Qt::darkCyan);
    colores.push_back(Qt::darkMagenta);
    colores.push_back(Qt::darkYellow);

    float percentage=0., numTotalDeals=0., numProductDeals=0.;
    QComboBox *combo=new QComboBox();
    QTableWidget *tabla=new QTableWidget();
    QWidget::paintEvent(e);
    QPainter painter;
    //QFont font;
    painter.begin(this);
    Nightcharts PieChart;
    PieChart.setType(Nightcharts::Dpie);//{Histogramm,Pie,DPie};
    PieChart.setLegendType(Nightcharts::Round);//{Round,Vertical}

    //PieChart.setCords(x, y,this->width()/3,this->height()/3);
    PieChart.setCords(140,70,this->width()/3,this->height()/3);
    DB->getDataFromTable(combo, "tipo_producto");
    num_productos=combo->count();

    numTotalDeals=(float)DB->getDealsCount();


    for (int i=0; i<num_productos; i++)
    {
        DB->getDeals(tabla,combo->itemText(i));
        numProductDeals=(float)tabla->rowCount();
        if (numProductDeals)
        {
            percentage=(numProductDeals/numTotalDeals)*100;
            PieChart.addPiece(combo->itemText(i),colores[color],percentage);
            if (color==11)
                color=0;
            else
                color++;
        }
    }
    PieChart.draw(&painter);
    PieChart.drawLegend(&painter);
    delete tabla;
    delete combo;
}

MyDoubleSpinBox::MyDoubleSpinBox(QWidget *parent):QDoubleSpinBox(parent)
{
}

QString MyDoubleSpinBox::textFromValue(double value) const
{
    QString text = QDoubleSpinBox::textFromValue(value);
    return text.replace(QLocale().decimalPoint(), QLatin1Char('.'));
}

double MyDoubleSpinBox::valueFromText(const QString& text) const
{
    QString txt=text;
    txt.replace(QLatin1Char('.'), QLocale().decimalPoint());
    return txt.toDouble();
}

DoubleSpinBoxDelegate::DoubleSpinBoxDelegate(QObject *parent):QItemDelegate(parent)
{
}

QWidget *DoubleSpinBoxDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &/* option */,
    const QModelIndex &/* index */) const
{
    MyDoubleSpinBox *editor = new MyDoubleSpinBox(parent);

    editor->setRange(0,99999999999);
    editor->setDecimals(6);

    return editor;
}
void DoubleSpinBoxDelegate::setEditorData(QWidget *editor,
                                    const QModelIndex &index) const
{
    double value = index.model()->data(index, Qt::EditRole).toString().replace(".",",").toDouble();
    MyDoubleSpinBox *spinBox = static_cast<MyDoubleSpinBox*>(editor);
    spinBox->setValue(value);
}

void DoubleSpinBoxDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                   const QModelIndex &index) const
{
    MyDoubleSpinBox *spinBox = static_cast<MyDoubleSpinBox*>(editor);
    spinBox->interpretText();
    double value = spinBox->value();
    QString txt = QString("%1").arg(value);
    txt.replace(",",".");
    model->setData(index, txt, Qt::EditRole);

}

void DoubleSpinBoxDelegate::updateEditorGeometry(QWidget *editor,
    const QStyleOptionViewItem &option, const QModelIndex &/* index */) const
{
    editor->setGeometry(option.rect);
}

