//****************************************************************************//
// Manuel Martínez Liébana                                                    //
// TFC - Ingeniería Técnica Informática de Gestión                            //
// UOC - 2012                                                                 //
//****************************************************************************//

#ifndef UTILS_H
#define UTILS_H
#include <QItemDelegate>
#include <QWidget>
#include <QObject>
#include <QStyleOptionViewItem>
#include <QModelIndex>
#include <QDoubleSpinBox>
#include <QFrame>

class MyQFrame: public QFrame
 {
     Q_OBJECT

 public:
     MyQFrame(QWidget *parent = 0);
     void paintEvent(QPaintEvent *e);
 };



class MyDoubleSpinBox: public QDoubleSpinBox
 {
     Q_OBJECT

 public:
     MyDoubleSpinBox(QWidget *parent = 0);
     QString textFromValue(double value) const;
     double valueFromText(const QString& text) const;
 };

class DoubleSpinBoxDelegate : public QItemDelegate
 {
     Q_OBJECT

 public:
     DoubleSpinBoxDelegate(QObject *parent = 0);

     QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const;


     void setEditorData(QWidget *editor, const QModelIndex &index) const;
     void setModelData(QWidget *editor, QAbstractItemModel *model,
                       const QModelIndex &index) const;

     void updateEditorGeometry(QWidget *editor,
         const QStyleOptionViewItem &option, const QModelIndex &index) const;
 };




#endif // UTILS_H
