//****************************************************************************//
// Manuel Martínez Liébana                                                    //
// TFC - Ingeniería Técnica Informática de Gestión                            //
// UOC - 2012                                                                 //
//****************************************************************************//

#ifndef VALORACION_H
#define VALORACION_H
#include <ql/quantlib.hpp>
#include <boost/timer.hpp>
#include <iostream>
#include <iomanip>
#include <QString>
#include <QDate>

#if defined(QL_ENABLE_SESSIONS)
namespace QuantLib {

    Integer sessionId() { return 0; }

}
#endif

QuantLib::Calendar *getCalendar(QString name);

void adjustCalendarHolidays(QString name, QuantLib::Calendar *cal);

QuantLib::VanillaSwap *getIRS(double nominal, QDate settlementDate, QDate maturityDate, QString currency, QString rol, double spread,
                              bool isForward, QDate fwdStart,
                              QString fixedFrequency, QString fixedBusinessConv, QString fixedCalConv, double fixedRate, QString discountCurveName,
                              QString floatingFrequency, QString floatingBusinessConv, QString floatingCalConv, QString indexName, QString forwardCurveName);

QuantLib::VanillaOption *getEuropeanOption(double nominal, QDate settlementDate, QDate maturityDate,
                                           QString currency, QString tipoOpcion, double spot,
                                           double optStrike, double tipoLibre, double volatilidad, QString convencionCalendario);

bool getMultipleValoration(QStringList deals, double *NPV, double *delta, double *gamma, double *rho, double *theta, double *vega, QStringList *errores);


#endif // VALORACION_H
